/* Micro-C Code Generatation Part for intel386 */

#define EXTERN 

/* Micro-C header file */

#define DEBUG	error(-1)

/*
*/

typedef struct { int a; } FILE;

#define SIZE_INT   4

#define INT	(-1)
#define CHAR	(-2)
#define UNSIGNED	(-3)
#define POINTER (-4)
#define ARRAY	(-5)
#define STRUCT	(-6)
#define UNION	(-7)
#define FUNCTION	(-8)
#define EMPTY	(-9)

#define STATIC	(-10)
#define GOTO	(-11)
#define RETURN	(-12)
#define BREAK	(-13)
#define CONTINUE	(-14)
#define IF	(-15)
#define ELSE	(-16)
#define FOR	(-17)
#define DO	(-18)
#define WHILE	(-19)
#define SWITCH	(-20)
#define CASE	(-21)
#define DEFAULT (-22)
#define RESERVE (-23)
#define TAG	(-24)
#define FIELD	(-25)
#define IDENT	(-26)
#define STRING	(-27)
#define MACRO	(-28)
#define BLABEL	(-29)
#define FLABEL	(-30)
#define TYPEDEF (-31)
#define SIZEOF	(-32)
#define TYPE	(-33)
#define LONG	(-34)
#define SHORT	(-35)

#define TOP	0
#define GDECL	1
#define GSDECL	2
#define GUDECL	3
#define ADECL	4
#define LDECL	5
#define LSDECL	6
#define LUDECL	7
#define STADECL 8
#define STAT	9
#define GTDECL	10
#define LTDECL	11

#define GVAR	1
#define RGVAR	2
#define CRGVAR	3
#define LVAR	4
#define RLVAR	5
#define CRLVAR	6
#define CONST	7
#define FNAME	8
#define INDIRECT	9
#define RINDIRECT	10
#define CRINDIRECT	11
#define ADDRESS 12
#define MINUS	13
#define LNOT	14
#define BNOT	15
#define INC	16
#define POSTINC 17
#define PREINC	18
#define CPOSTINC	19
#define CPREINC 20
#define DEC	21
#define CPOSTDEC	22
#define CPREDEC 23
#define MUL	24
#define UMUL	25
#define DIV	26
#define UDIV	27
#define MOD	28
#define UMOD	29
#define ADD	30
#define SUB	31
#define RSHIFT	32
#define URSHIFT 33
#define LSHIFT	34
#define ULSHIFT 35
#define GT	36
#define UGT	37
#define GE	38
#define UGE	39
#define LT	40
#define ULT	41
#define LE	42
#define ULE	43
#define EQ	44
#define NEQ	45
#define BAND	46
#define EOR	47
#define BOR	48
#define LAND	49
#define LOR	50
#define COND	51
#define ASS	52
#define CASS	53
#define ASSOP	54
#define CASSOP	55
#define COMMA	56
#define LPAR	57
#define RPAR	58
#define LBRA	59
#define RBRA	60
#define LC	61
#define RC	62
#define COLON	63
#define SM	64
#define PERIOD	65
#define ARROW	66

#define US	1
#define AS	100

#define FILERR	1
#define DCERR	2
#define STERR	3
#define EXERR	4
#define CNERR	5
#define CHERR	6
#define GSERR	7
#define LSERR	8
#define STRERR	9
#define LNERR	10
#define EOFERR	11
#define MCERR	12
#define INCERR	13
#define HPERR	14
#define TYERR	15
#define LVERR	16
#define UDERR	17
#define OPTION	18

#define GSYMS	450
#define LSYMS	50

#define HEAPSIZE	1000
#define CHEAPSIZE	3000
#define LBUFSIZE	256

#define FILES 3

EXTERN int sym,ch,chsave,type,mode,gfree,lfree,mflag,lineno,glineno;
EXTERN int labelno,gpc,lvar,disp;
EXTERN int symval,args,heap[HEAPSIZE];
EXTERN int blabel,clabel,dlabel,cslabel,ilabel,control,ac,ac2,lsrc,chk,asmf;

EXTERN unsigned hash;

EXTERN char linebuf[LBUFSIZE],cheap[CHEAPSIZE],*chptr,*chptrsave;
EXTERN char name[9],*cheapp,**av,/*obuf[320],*/*sptr,escape();

EXTERN FILE *obuf;

typedef struct nametable {
	char nm[9];
	int sc,ty,dsp; } NMTBL;

EXTERN NMTBL ntable[GSYMS+LSYMS],*nptr,*gnptr,*decl0(),*decl1(),*lsearch(),*gsearch();

EXTERN struct {int fd,ln;/*char fcb[320]*/FILE *fcb;} *filep,filestack[FILES];

EXTERN int emit_data();

 int  label = 0;
 char *comments = "#####";

 int  creg;     /* current register */
 char *crn;     /* current register name */
 int  lreg;     /* operand register */
 int  dreg;     /* temporary register */
 int  xreg;     /* pointer register */
 char *xrn;     /* pointer register name */
 int  reg_sp;   /* REGister Stack-Pointer */

 char **reg_name;
 char **l_reg_name;

#define REG_EAX   0
#define REG_EBX   1
#define REG_ECX   2
#define REG_EDX   3
#define REG_ESI   4


#define MAX_REGISTER 4    /* intel386Υ쥸4ĤȤ*/
 char regs[MAX_REGISTER+1];   /* ȤƤ쥸򼨤ե饰 */
 char reg_stack[MAX_REGISTER];  /* ºݤΥ쥸ΰ */

int get_register() {    /* ȤƤʤ쥸Ĵ٤ */
    int i;
    for(i=0;i<MAX_REGISTER;i++) {
	if (! regs[i]) {    /* ȤƤʤʤ */
	    regs[i]=1;      /* Υ쥸ȤȤ */
	    return i;       /* ξɽֹ֤ */
	}
    }
    return -1;    /* Ƥ꤬ʤʤ顢ɽ -1 ֤ */
}

void free_register(i) {    /* ʤʤä쥸 */
    regs[i]=0;
}

int pop_register() {     /* 쥸ͤФ */
    int i,j;

    j = creg;
    i = reg_stack[--reg_sp];

    if(i<0) {
	return i;
    } else {
	lreg = i;
	regs[i]=0;
	return creg;
    }
}

void emit_init() {
    int i;
    for(i=0;i<MAX_REGISTER;i++) regs[i]=0;
    creg = get_register();
    xreg = REG_ESI;
    crn = reg_name[creg];
    xrn = reg_name[xreg];
    dreg = get_register();
    regs[creg] = 1;
    regs[dreg] = 1;
    reg_sp = 0;
}

void emit_push(){
    int new_reg;
    new_reg = get_register();
    if(new_reg<0) {                     /* ⤦쥸ʤ */
	reg_stack[reg_sp++] =  -1;
	printf("\tpushl %s\n",crn);
    } else {
	reg_stack[reg_sp++] = creg;     /* push 뤫˥쥸Ȥ */
	creg = new_reg;
	crn = reg_name[creg];
    }
}

gexpr(e1)
int e1;
{
	emit_init();
	g_expr(e1);
}

g_expr(e1)
int e1;
{int e2,e3;
	if (chk) return;
	e2 = cadr(e1);
	switch (car(e1)){
	case GVAR:   
             /* leaxy(e2); */
		regs[xreg]=1;
	        printf("\tmovl $_%s,%s\n",caddr(e1),xrn);
		return;
	case RGVAR:
	     /* lddy(e2); */
	        printf("\tmovl _%s,%s\n",caddr(e1),crn);
		regs[xreg]=0;
		return;
	case CRGVAR:
	     /* ldby(e2); */ /* sex(); */
	        printf("\tmovsbl _%s,%s\n",caddr(e1),crn);
		regs[xreg]=0;
		return;
	case LVAR:
		/* leaxu(e2); */
		regs[xreg]=1;
	        printf("\tlea %d(%%ebp),%s\n",e2,xrn);
		return;
	case RLVAR:
		/* lddu(e2); */
	        printf("\tmovl %d(%%ebp),%s\n",e2,crn);
		regs[xreg]=0;
		return;
	case CRLVAR:
		/* ldbu(e2); */ /* sex(); */
	        printf("\tmovsbl %d(%%ebp),%s\n",e2,crn);
		regs[xreg]=0;
		return;
	case FNAME:
		/* leaxpcr((NMTBL *)e2); */
		/* tfrxd(); */
	        printf("\tmovl $_%s,%s\n",((NMTBL *)e2)->nm,crn);
		regs[xreg]=0;
		return;
	case CONST:  /* ͤ0Ǥ̤ʽϤʤ */
	        /* lddim(e2); */
	        printf("\tmovl $%d,%s\n",e2,crn);
		regs[xreg]=0;
		return;
	case STRING:
		string(e1);
		return;
	case FUNCTION:
		function(e1);
		return;
	case INDIRECT:
		indirect(e1);
		return;
	case RINDIRECT: case CRINDIRECT:
		rindirect(e1);
		return;
	case ADDRESS:
		g_expr(e2);
		/* tfrxd();  */
		regs[xreg]=1;
		printf("\tmovl %s,%s\n", xrn,crn);
		return;
	case MINUS:  /* 쥸Фnegl¹Ԥм¸ǽ */
	        g_expr(e2);
		printf("\tnegl %s\n", crn);
		regs[xreg]=0;
		return;
	case BNOT:   /*  */
		g_expr(e2);
		printf("\tnotl %s\n", crn);
		regs[xreg]=0;
		return;
	case PREINC:
		switch (car(e2))
		{case GVAR: 
			/* ldd(e2);
			adddim(caddr(e1));
			std(e2); */
			if (caddr(e1)==1) {
				printf("\tincl _%s\n",caddr(e2));
				printf("\tmovl _%s,%s\n",caddr(e2),crn);
				return;
			} 
			printf("\tmovl _%s,%s\n",caddr(e2),crn);
			printf("\taddl $%d,%s\n",caddr(e1),crn);
			printf("\tmovl %s,_%s\n",crn,caddr(e2));
			regs[xreg]=0;
			return;
		case LVAR:
			if (caddr(e1)==1) {
				printf("\tincl %d(%%ebp)\n",cadr(e2));
				printf("\tmovl %d(%%ebp),%s\n",cadr(e2),crn);
				return;
			} 
			printf("\tmovl %d(%%ebp),%s\n",cadr(e2),crn);
			printf("\taddl $%d,%s\n",cadr(e1),crn);
			printf("\tmovl %s,%d(%%ebp)\n",crn,cadr(e2));
			regs[xreg]=0;
			return;
		default:
			g_expr(e2);
			/* lddx();
			adddim(caddr(e1));
			stdx(); */
			if (caddr(e1)==1) {
				printf("\tincl (%s)\n",xrn);
				printf("\tmovl (%s),%s\n",xrn,crn);
				return;
			} 
			printf("\tmovl (%s),%s\n",xrn,crn);
			printf("\taddl $%d,%s\n",caddr(e1),crn);
			printf("\tmovl %s,(%s)\n",crn,xrn);
			regs[xreg]=0;
			return;
		}
	case POSTINC:
		switch (car(e2))
		{case GVAR: 
			/* ldd(e2);
			adddim(e3 = caddr(e1));
			std(e2);
			subdim(e3); */
			if (caddr(e1)==1) {
				printf("\tmovl _%s,%s\n",caddr(e2),crn);
				printf("\tincl _%s\n",caddr(e2));
				return;
			}
			printf("\tmovl _%s,%s\n",caddr(e2),crn);
			printf("\taddl $%d,_%s\n",caddr(e1),caddr(e2));
			regs[xreg]=0;
			return;
		case LVAR:
			/* ldd(e2);
			adddim(e3 = caddr(e1));
			std(e2); 
			subdim(e3); */
			if (caddr(e1)==1) {
				printf("\tmovl %d(%%ebp),%s\n",cadr(e2),crn);
				printf("\tincl %d(%%ebp)\n",cadr(e2));
				return;
			}
			printf("\tmovl %d(%%ebp),%s\n",cadr(e2),crn);
			printf("\taddl $%d,%d(%%ebp)\n",caddr(e1),cadr(e2));
			regs[xreg]=0;
			return;
		default:
			g_expr(e2);
			/* lddx();
			adddim(e3=caddr(e1));
			stdx();
			subdim(e3); */
			if (caddr(e1)==1) {
				printf("\tmovl (%s),%s\n",xrn,crn);
				printf("\tincl (%s)\n",xrn);
				return;
			}
			printf("\tmovl (%s),%s\n",xrn,crn);
			printf("\taddl $%d,(%s)\n",caddr(e1),xrn);
			regs[xreg]=0;
			return;
		}
	case CPOSTINC:
		/*   char *p; *p++ */
		g_expr(e2);
		/* 
		ldbx();
		incx();
		 sex(); */
	        printf("\tmovsbl (%s),%s\n",xrn,crn);
	        printf("\tincl (%s)\n",xrn);
		regs[xreg]=0;
		return;
	case CPREINC:
		g_expr(e2);
		/* incx();
		ldbx();
		sex(); */
	        printf("\tincl (%s)\n",xrn);
	        printf("\tmovsbl (%s),%s\n",xrn,crn);
		regs[xreg]=0;
		return;
	case CPOSTDEC:
		g_expr(e2);
	        printf("\tmovsbl (%s),%s\n",xrn,crn);
	        printf("\tdecl (%s)\n",xrn);
		regs[xreg]=0;
		return;
	case CPREDEC:
		g_expr(e2);
	        printf("\tdecl (%s)\n",xrn);
	        printf("\tmovsbl (%s),%s\n",xrn,crn);
		regs[xreg]=0;
		return;
	case MUL: case UMUL:
		if (car(e3=caddr(e1)) == CONST)
		{	
			regs[xreg]=0;
			if (0 < (e3 = cadr(e3)) && e3 <= 10)
			{	g_expr(e2);
				switch (e3)
				{case 8:
					asld(3);
					return;
				case 4:
					asld(2);
					return;
				case 2:
					asld(1);
					return;
				case 1:
					return;
				case 10:
					asld(1);
				case 5:
					printf("\tmovl %s,%s\n",crn,reg_name[dreg]);
					asld(2);
					printf("\taddl %s,%s\n",reg_name[dreg],crn);
					return;
				case 6:
					asld(1);
				case 3:
					printf("\tmovl %s,%s\n",crn,reg_name[dreg]);
					asld(1);
					printf("\taddl %s,%s\n",reg_name[dreg],crn);
					return;
				case 9: case 7:
					printf("\tmovl %s,%s\n",crn,reg_name[dreg]);
					asld(3);
					if (e3 == 9) 
						printf("\taddl %s,%s\n",reg_name[dreg],crn);
					else 
						printf("\tsubl %s,%s\n",reg_name[dreg],crn);
					return;
				}
			}
		}
	case DIV:    case UDIV:	   case MOD:	case UMOD:
	case LSHIFT: case ULSHIFT: case RSHIFT: case URSHIFT:
	case ADD: case SUB: case BAND: case EOR: case BOR:
		regs[xreg]=0;
		machinop(e1);
		return;
	case COND:
		e2=fwdlabel();
		b_expr(cadr(e1),0,e2);
		g_expr(caddr(e1));
		jmp(e3=fwdlabel());
		fwddef(e2);
		g_expr(cadddr(e1));
		fwddef(e3);
		return;
	case ASS: case CASS:
		assign(e1);
		return;
	case ASSOP: case CASSOP:
		assop(e1);
		return;
	case COMMA:
		g_expr(e2);
		g_expr(caddr(e1));
		return;
	default:
		g_expr(e2);
		printf("\tandl %s,%s\n",crn,crn);
		printf("\t%s %s\n","sete",l_reg_name[creg]);
		printf("\tmovzbl %s,%s\n",l_reg_name[creg],crn);
		regs[xreg]=0;
	}
}

bexpr(e1,cond,l1)
int e1,l1;
char cond;
{
	emit_init();
	b_expr(e1,cond,l1);
}

b_expr(e1,cond,l1)
int e1,l1;
char cond;
{int e2,l2;
        if (chk) return;
        e2=cadr(e1);
        switch(car(e1))
        {case LNOT:
                b_expr(e2,!cond,l1);
                return;
        case GT:
                rexpr(e1,l1,cond?"g":"le");
                return;
        case UGT:
                rexpr(e1,l1,cond?"a":"bs");
                return;
        case GE:
                rexpr(e1,l1,cond?"ge":"l");
                return;
        case UGE:
                rexpr(e1,l1,cond?"ae":"b");
                return;
        case LT:
                rexpr(e1,l1,cond?"l":"ge");
                return;
        case ULT:
                rexpr(e1,l1,cond?"b":"ae");
                return;
        case LE:
                rexpr(e1,l1,cond?"le":"g");
                return;
        case ULE:
                rexpr(e1,l1,cond?"bs":"a");
                return;
        case EQ:
                rexpr(e1,l1,cond?"e":"ne");
                return;
        case NEQ:
                rexpr(e1,l1,cond?"ne":"e");
                return;
        case LAND:
                b_expr(e2,0,cond?(l2=fwdlabel()):l1);
                b_expr(caddr(e1),cond,l1);
                if(cond) fwddef(l2);
                return;
        case LOR:
                b_expr(e2,1,cond?l1:(l2=fwdlabel()));
                b_expr(caddr(e1),cond,l1);
                if(!cond) fwddef(l2);
                return;
        case CRGVAR:
		printf("\tcmpb $0,_%s\n",caddr(e2));
                jcond(l1,cond);
                return;
        case CRLVAR:
		printf("\tcmpb $0,%d(%%ebp)\n",cadr(e2));
                jcond(l1,cond);
                return;
        case CONST:
                if(cond&&e2||!cond&&!e2) jmp(l1);
                return;
        default:g_expr(e1);
		printf("\tcmpl $0,%s\n",crn);
                jcond(l1,cond);
                return;
        }
}

string(e1)
int e1;
{char *s;
int i,l,lb;
        s=(char *)cadr(e1);
        lb=fwdlabel();
	printf("\tjmp _%d",lb);
	printf("\t.ascii \"%s\"\\0",s);
        fwddef(lb);
}

function(e1)
int e1;
{int e2,e3,e4,e5,nargs;
NMTBL *n;
	e2 = cadr(e1);
	nargs = 0;
	for (e3 = caddr(e1); e3; e3 = cadr(e3))
	{	n=(NMTBL *)(e5=(cadr(e4 = car(e3))));
		switch(car(e4))
		{case FNAME:
			printf("\tlea $%s,%s\n",n->nm,crn);
			printf("\tpushl %s\n",crn);
			break;
		case ADDRESS:
			g_expr(e5);
			printf("\tpushl %s\n",xrn);
			break;
		default:g_expr(e4);
			printf("\tpushl %s\n",crn);
		}
		++nargs;
	}
	if (car(e2) == FNAME)
	{	n=(NMTBL *)cadr(e2);
		printf("\tcall\t_%s\n",n->nm);
	}
	else
	{	g_expr(e2);
		printf("\tcall\t*%s\n",xrn);
	}
	if (nargs) printf("\taddl $%d,%%esp\n",4*nargs);
}
indirect(e1)    /* left value */
int e1;
{int e2,e3,e4;
	e3 = cadr(e2 = cadr(e1));
	switch(car(e2))
	{case RGVAR: case RLVAR:   /* *p */
		ldx(e2);
		return;
	case ADD:       /*    *(p + 5) */
		if(car(e3)==ADDRESS)
		{	g_expr(caddr(e2));  /* must be pointer */
			g_expr(cadr(e3));   /* must be value */
			/* opdx("LEAX"); */
			printf("\taddl %s,%s\n",crn,xrn);
			return;
		}
		switch(car(e4 = caddr(e2)))
		{case RGVAR: case RLVAR:
			g_expr(e3);
			ldx(e4);
			/* opdx("LEAX"); */
			printf("\taddl %s,%s\n",crn,xrn);
			return;
		}
	default:
		g_expr(e2);
		printf("\tmovl %s,%s\n",crn,xrn);
		/* tfrdx(); */
	}
}

machinop(e1)
int e1;
{int e2,e3,op;
	e2 = cadr(e1);
	op = car(e1);
	switch (car(e3 = caddr(e1)))
	{case RGVAR: case RLVAR: case CONST:
		g_expr(e2);
		if (simpop(op)) 
			oprt(op,e3);
		else 
			oprt_mul(op,e3);
		return;
	default:
		g_expr(e3);
		emit_push();
		g_expr(e2);
		tosop(car(e1));
		return;
	}
}

rindirect(e1)   /* *(p +5 ) */
int e1;
{char *op;
int e2,e3,e4,byte,l;
	op = ((byte = (car(e1) == CRINDIRECT)) ? "movsbl" : "movl");
	e3 = cadr(e2 = cadr(e1));
	switch (car(e2)) {
	case RGVAR: 
		/*    movl   _i,%esi
		      movsbl (%esi),%eax  */
		printf("\tmovl _%s,%s\n",caddr(e2),xrn);
		printf("\t%s (%s),%s\n",op,xrn,crn);
		return;
	case RLVAR:
		/*    movl   -6(%ebp),%esi
		      movsbl (%esi),%eax  */
		printf("\tmovl %d(%%ebp),%s\n",cadr(e2),xrn);
		printf("\t%s (%s),%s\n",op,xrn,crn);
		return;
	case ADD:
		/*    movsbl (%esi+%eax),%eax  */
		if(car(e3)==ADDRESS)          /*   *((p+3)+3) */
		{	g_expr(caddr(e2));   /* creg data */
			g_expr(cadr(e3));    /* xrn address */
			printf("\t%s (%s,%s),%s\n",op,crn,xrn,crn);
			return;
		}
		switch(car(e4=caddr(e2))) {      /*   *(p+3) */
		case RGVAR: 
			/*    movl   _i,%esi
			      movsbl (%esi+%eax),%eax  */
			g_expr(e3);
			printf("\tmovl _%s,%s\n",caddr(e2),xrn);
			printf("\t%s (%s,%s),%s\n",op,crn,xrn,crn);
			return;
		case RLVAR:
			/*    movl   -6(%ebp),%esi
			      movsbl (%esi+%eax),%eax  */
			g_expr(e3);
			printf("\tmovl %d(%%ebp),%s\n",cadr(e2),xrn);
			printf("\t%s (%s,%s),%s\n",op,crn,xrn,crn);
			return;
		case CONST:
			switch (car(e3)) {
			case RGVAR: 
				printf("\t%s _%s+%d,%s\n",op,caddr(e3),cadr(e4),crn);
				/* 
				ldx(e3);
				indexx(op,cadr(e4));
				sextend(byte);
				*/
				return;
			case RLVAR:
				/*    movl   -6(%ebp),%esi
				      movsbl 12(%esi+%eax),%eax  */
				printf("\tmovl %d(%%ebp),%s\n",cadr(e3),xrn);
				printf("\t%s %d(%s,%%ebp),%s\n",op,cadr(e4),xrn,crn);
				/* 
				ldx(e3);
				indexx(op,cadr(e4));
				sextend(byte); */
				return;
			}
		default:
			g_expr(e3);
			emit_push();
			g_expr(e4);
			if (pop_register()) {
			    printf("\t%s (%s,%s),%s\n",op,reg_name[lreg],crn,crn);
			} else {
			    printf("\tpopl %s\n",reg_name[dreg]);
			    printf("\t%s (%s,%s),%s\n",op,reg_name[dreg],crn,crn);
			}  
			/* 
			pulx();
			opdx(op);
			sextend(byte);
			  */
			return;
		}
	case PREINC:
		/*    *++p */
		if ((l = caddr(e2)) == 1)
		    switch (car(e3)) {
		    case GVAR: 
			printf("\tincl _%s\n",caddr(e3));
			printf("\t%s %s,%s\n",op,caddr(e3),crn);
			return;
		    case LVAR:
			printf("\tincl %d(%%ebp)\n",cadr(e3));
			printf("\t%s %s,%s\n",op,caddr(e3),crn);
			return;
		    /*	ldx(e3);
			    predecx(op,l);
			    stx(e3);
			    sextend(byte);
			    return; */
		    }
		else 
		    switch (car(e3)) {
		    case GVAR: 
			printf("\taddl $%d,_%s\n",caddr(e2),caddr(e3));
			printf("\t%s %s,%s\n",op,caddr(e3),crn);
			return;
		    case LVAR:
			printf("\taddl $%d,%d(%%ebp)\n",caddr(e2),cadr(e3));
			printf("\t%s %s,%s\n",op,caddr(e3),crn);
			return;
		    }
		break;
	case POSTINC:
		/*    *p++ */
		if ((l = caddr(e2)) == 1)
		    switch (car(e3)) {
		    case GVAR: 
			printf("\t%s %s,%s\n",op,caddr(e3),crn);
			printf("\tincl _%s\n",caddr(e3));
			return;
		    case LVAR:
			printf("\t%s %s,%s\n",op,caddr(e3),crn);
			printf("\tincl %d(%%ebp)\n",cadr(e3));
			return;
		    }
		else 
		    switch (car(e3)) {
		    case GVAR: 
			printf("\t%s %s,%s\n",op,caddr(e3),crn);
			printf("\taddl $%d,_%s\n",caddr(e2),caddr(e3));
			return;
		    case LVAR:
			printf("\t%s %s,%s\n",op,caddr(e3),crn);
			printf("\taddl $%d,%d(%%ebp)\n",caddr(e2),cadr(e3));
			return;
		    }
		break;
	}
	g_expr(e2);
	printf("\t%s (%s),%s\n",op,crn,crn);
	/* tfrdx();
	indexx(op,0);
	sextend(byte); */
}
assign(e1)
int e1;
{char *op;
int e2,e3,e4,e5,l;
	op = (car(e1) == CASS ? "movb" : "movl");
	e3 = cadr(e2 = cadr(e1));
	e4 = caddr(e1);
	switch(car(e2)) {
	case GVAR:      /*   i=3 */
		g_expr(e4);
		printf("\t%s %s,_%s\n",op,crn,caddr(e2));
		return;
	case LVAR:
		g_expr(e4);
		printf("\t%s %s,%d(%%ebp)\n",op,crn,cadr(e2));
		return;
	case INDIRECT:  /*  *i = 3 */
		switch(car(e3)) {
		case RGVAR: 
			g_expr(e4);
			printf("\tmovl _%s,%s\n",caddr(e3),xrn);
			printf("\t%s %s,(%s)\n",op,crn,xrn);
		case RLVAR:
			g_expr(e4);
			printf("\tmovl %d(%%ebp),%s\n",cadr(e3),xrn);
			printf("\t%s %s,(%s)\n",op,crn,xrn);
			return;
		case ADD:/*  i[3] = 3 */
			if (car(caddr(e3)) == CONST)
				switch (car(e5=cadr(e3))) {
				case RGVAR: 
					g_expr(e4);
					printf("\tmovl _%s,%s\n",caddr(e5),xrn);
					printf("\t%s %s,%d(%s)\n",op,crn,cadr(caddr(e3)),xrn);
					return;
				case RLVAR:
					g_expr(e4);
					printf("\tmovl %d(%%ebp),%s\n",cadr(e5),xrn);
					printf("\t%s %s,%d(%s)\n",op,crn,cadr(caddr(e3)),xrn);
					/* 
					ldx(e5);
					indexx(op,cadr(caddr(e3)));
					  */
					return;
				}
			break;
		case PREINC:/*  *++i = 3 */
			if ((l = caddr(e3)) == -1)
				switch (car(e5=cadr(e3))) {
				case GVAR: 
					g_expr(e4);
					printf("\tincl _%s\n",caddr(e5));
					printf("\tmovl _%s,%s\n",caddr(e5),xrn);
					printf("\t%s %s,%d(%s)\n",op,crn,cadr(caddr(e3)),xrn);
					/* ldx(e5);
					predecx(op,l);
					stx(e5); */
					return;
				case LVAR:
					g_expr(e4);
					printf("\tincl %d(%%ebp)\n",cadr(e5));
					printf("\tmovl %d(%%ebp),%s\n",cadr(e5),xrn);
					printf("\t%s %s,%d(%s)\n",op,crn,cadr(caddr(e3)),xrn);
					return;
				}
			else 
				switch (car(e5=cadr(e3))) {
				case GVAR: 
					g_expr(e4);
					printf("\taddl _%s,$%d\n",caddr(e5),l);
					printf("\tmovl _%s,%s\n",caddr(e5),xrn);
					printf("\t%s %s,%d(%s)\n",op,crn,cadr(caddr(e3)),xrn);
					/* ldx(e5);
					predecx(op,l);
					stx(e5); */
					return;
				case LVAR:
					g_expr(e4);
					printf("\taddl %d(%%ebp)\n",cadr(e5),l);
					printf("\tmovl %d(%%ebp),%s\n",cadr(e5),xrn);
					printf("\t%s %s,%d(%s)\n",op,crn,cadr(caddr(e3)),xrn);
					return;
				}
			break;
		case POSTINC:/*  *i++ = 3 */
			if ((l = caddr(e3)) == -1)
				switch (car(e5=cadr(e3))) {
				case GVAR: 
					g_expr(e4);
					printf("\tmovl _%s,%s\n",caddr(e5),xrn);
					printf("\tincl _%s\n",caddr(e5));
					printf("\t%s %s,%d(%s)\n",op,crn,cadr(caddr(e3)),xrn);
					/* ldx(e5);
					predecx(op,l);
					stx(e5); */
					return;
				case LVAR:
					g_expr(e4);
					printf("\tmovl %d(%%ebp),%s\n",cadr(e5),xrn);
					printf("\tincl %d(%%ebp)\n",cadr(e5));
					printf("\t%s %s,%d(%s)\n",op,crn,cadr(caddr(e3)),xrn);
					return;
				}
			else 
				switch (car(e5=cadr(e3))) {
				case GVAR: 
					g_expr(e4);
					printf("\tmovl _%s,%s\n",caddr(e5),xrn);
					printf("\taddl _%s,$%d\n",caddr(e5),l);
					printf("\t%s %s,%d(%s)\n",op,crn,cadr(caddr(e3)),xrn);
					/* ldx(e5);
					predecx(op,l);
					stx(e5); */
					return;
				case LVAR:
					g_expr(e4);
					printf("\tmovl %d(%%ebp),%s\n",cadr(e5),xrn);
					printf("\taddl %d(%%ebp)\n",cadr(e5),l);
					printf("\t%s %s,%d(%s)\n",op,crn,cadr(caddr(e3)),xrn);
					return;
				}
			break;
		}
	}
	switch (car(e4))
	{case RGVAR: case CRGVAR: case RLVAR: case CRLVAR: case CONST:
		/*   i = 4;   i = j; simple right */
		g_expr(e2);
		g_expr(e4);
		break;
	default:
		/*   i[j+4] = i[j+5]; */ 
		g_expr(e4);
		emit_push();
		g_expr(e2);
		if (pop_register()) {
		    printf("\tmovl %s,%s",reg_name[lreg],crn);
		} else {
		    printf("\tpopl %s",crn);
		}
		/* pulld(); */
	}
	printf("\t%s %s,(%s)",op,crn,xrn);
	/* indexx(op,0); */
	return;
}

assop(e1)
int e1;
{int e2,e3,byte,op;
char *move;

        /*   i += 5 */
	move = ((byte = (car(e1) == CASSOP)) ? "movsbl" : "movl");
	e2 = cadr(e1);
	e3 = caddr(e1);
	op = cadddr(e1);
	switch (car(e2)) {
	case GVAR: case LVAR:
		switch (car(e3)) {
		case RGVAR: case RLVAR: case CONST:
			ld_index(move,e2);
			if (simpop(op)) {	
			    oprt(op,e3);
			} else {
			    oprt_mul(op,e3);
			}
			st_index(move,e2);
			return;
		default:
			g_expr(e3);
			emit_push();
			ld_index(move,e2);
			tosop(op);
			st_index(move,e2);
			return;
		}
	default:
		switch (car(e3)) {
		case RGVAR: case RLVAR: case CONST:
			g_expr(e2);
			ldx_indexx(move,0);
			if (simpop(op)) {	
			    oprt(op,e3);
			} else {
			    oprt_mul(op,e3);
			}
			stxindex(move,0);
			return;
		default:
			g_expr(e3);
			emit_push();
			g_expr(e2);
			ldx_indexx(move,0);
			tosop(op);
			stxindex(move,0);
			return;
		}
	}
}
simpop(op)
int op;
{	return (op == ADD || op == SUB ||
		op == BAND || op == EOR || op == BOR ||
		op == LSHIFT || op == ULSHIFT || op == RSHIFT || op==URSHIFT);
}

oprt(op,e)
int op,e;
{	
        int e1;
        e1 = car(e);
	switch (op) {
	case ADD:
		printf("\taddl ");
		break;
	case SUB:
		printf("\tsubl ");
		break;
	case BAND: 
		printf("\tandl ");
		break;
	case EOR: 
		printf("\txorl ");
		break;
	case BOR:
		printf("\torl ");
		break;
	case LSHIFT:
	case ULSHIFT:
		shift_1("sall",e);
		return;
	case RSHIFT:
		shift_1("sarl",e);
		return;
	case URSHIFT:
		shift_1("shrl",e);
		return;
	default:
		error(-1);
	}
	if (e1==RGVAR) {
	        printf("_%s,%s\n",caddr(e),crn);
	} else if (e1==RLVAR) {
	        printf("%d(%%ebp),%s\n",cadr(e),crn);
	} else if (e1==CONST) {
	        printf("$%d,%s\n",cadr(e),crn);
	} else {
		error(-1);
	}
}

oprt_mul(op,e)
int op,e;
{	
        int e1,const_reg;

        e1 = car(e);
	div_setup(0);
	/* free hands on EAX,EDX */
	if (e1==CONST) {
	    if(regs[REG_EBX]) 
		const_reg = REG_ECX;
		if (regs[REG_ECX]) {
		    printf("\tpushl %%ecx\n");
		}
	    else
		const_reg = REG_EBX;
	    printf("\tmovl $%d,%s\n",cadr(e),reg_name[const_reg]);
	}
	switch (op) {
	case MUL:
	case UMUL:
		printf("\t%s ",op==MUL?"mull":"imull");
		break; 
	case DIV:
	case UDIV:
		printf("\tcltd\n");
		printf("\t%s ",op==DIV?"divl":"idvil");
		break;
	case MOD:
	case UMOD:
		printf("\tcltd\n");
		printf("\t%s ",op==MOD?"divl":"idvil");
		break;
	default:
		error(-1);
	}
	if (e1==RGVAR) {
	        printf("_%s\n",caddr(e));
	} else if (e1==RLVAR) {
	        printf("%d(%%ebp)\n",cadr(e));
	} else if (e1==CONST) {
	        printf("%s\n",reg_name[const_reg]);
		if(const_reg == REG_ECX && regs[REG_ECX]) 
		    printf("\tpopl %%ecx\n");
	} else {
		error(-1);
	}
	switch (op) {
	case MUL: case UMUL: case DIV: case UDIV:
		div_cleanup();
		break;
	case MOD: case UMOD:
		div_1cleanup1();
		break;
	}
}

asld(d)
int d;
{
    printf("\tsall $%d,%s\n",d,crn);
}

tosop(op)
int op;
{
    int orn;
    orn = pop_register();
    if(orn<0) {
	switch(op) {
	case LSHIFT:
	case ULSHIFT:
		shift("sall",orn);
		return;
	case RSHIFT:
		shift("sarl",orn);
		return;
	case URSHIFT:
		shift("shrl",orn);
		return;
	}
        printf("\tpopl %s\n",dreg);
    }
    switch(op) {
    case ADD:
	    printf("\taddl %s,%s\n",reg_name[dreg],crn);
	    return;
    case SUB:
	    printf("\tsubl %s,%s\n",reg_name[dreg],crn);
	    return;
    case BAND: 
	    printf("\tandl %s,%s\n",reg_name[dreg],crn);
	    return;
    case EOR: 
	    printf("\txorl %s,%s\n",reg_name[dreg],crn);
	    return;
    case BOR:
	    printf("\torl %s,%s\n",reg_name[dreg],crn);
	    return;
    case MUL:
    case UMUL:
	    div_setup(1);
	    printf("\t%s %s\n",op==MUL?"mull":"imull",reg_name[lreg]);
	    div_cleanup();
	    return;
    case DIV:
    case UDIV:
	    div_setup(1);
	    printf("\tcltd\n");
	    printf("\t%s %s\n",op==DIV?"divl":"idvil",reg_name[lreg]);
	    div_cleanup();
	    return;
    case MOD:
    case UMOD:
	    div_setup(1);
	    printf("\tcltd\n");
	    printf("\t%s %s\n",op==MOD?"divl":"idvil",reg_name[lreg]);
	    div_1cleanup1();
	    return;
    }
}

 char o_mrn,n_mrn,n_lreg;

div_setup(m) 
int m;
{
/*
      dreg  creg   lreg       creg
        EDX:EAX / [EBX/ECX] => EAX
 */
    int i;
    for(i=0;i<4;i++) {
	if (i==dreg) continue;
	if (i==creg) continue;
	if (i==lreg) continue;
        n_mrn = o_mrn = i;
    }
    n_lreg = lreg;

    if (creg!=REG_EAX) {
	if (regs[REG_EAX])
	    printf("\txchg %s,%%eax\n",crn);
	i = regs[REG_EAX]; regs[REG_EAX]=regs[creg]; regs[creg] = i;
        if (o_mrn==REG_EAX) {
	    n_mrn = creg;
        }
        if (lreg==REG_EAX) {
	    n_lreg = lreg;
        }
    }
    if (dreg!=REG_EDX) {
	if (regs[REG_EDX])
	    printf("\txchg %s,%%edx\n",reg_name[dreg]);
	i = regs[REG_EDX]; regs[REG_EDX]=regs[dreg]; regs[dreg] = i;
        if (n_mrn==REG_EDX) {
	    n_mrn = dreg;
        }
        if (n_lreg==REG_EDX) {
	    n_lreg = lreg;
        }
    }
}

div_cleanup() {
    int i;
    /*     EAX  creg,    EDX   dreg  */
    creg = REG_EAX; dreg = REG_EDX;
    crn = reg_name[creg];
    if (n_mrn!=o_mrn) {
	if (regs[n_mrn]) {
	    printf("\txchg %s,%s\n",reg_name[n_mrn],reg_name[o_mrn]);
	    if (o_mrn == REG_EAX) {
		creg = n_mrn;
		crn = reg_name[creg];
	    }
	    if (o_mrn == REG_EDX) {
		dreg = n_mrn;
	    }
	    i = regs[n_mrn]; regs[n_mrn]=regs[o_mrn]; regs[o_mrn] = i;
	}
    }
}

div_1cleanup1() 
{
    int i;
    /*     EDX  creg,    EAX   dreg  */
    creg = REG_EDX; dreg = REG_EAX;
    crn = reg_name[creg];
    if (n_mrn!=o_mrn) {
	if (regs[n_mrn]) {
	    printf("\txchg %s,%s\n",reg_name[n_mrn],reg_name[o_mrn]);
	    if (o_mrn == REG_EDX) {
		creg = n_mrn;
		crn = reg_name[creg];
	    }
	    if (o_mrn == REG_EAX) {
		dreg = n_mrn;
	    }
	    i = regs[n_mrn]; regs[n_mrn]=regs[o_mrn]; regs[o_mrn] = i;
	}
    }
}


shift(op,reg) 
char *op,*reg;
{
    int change;
    change= -1;
    if (reg) {
	if (lreg!=REG_ECX) {
	    printf("\txchg %s,%%ecx\n",reg_name[change=lreg]);
	}
    } else {
	if (dreg!=REG_ECX && regs[REG_ECX]) {
	    printf("\txchg %s,%%ecx\n",reg_name[change=dreg]);
	}
	printf("\tpopl %%ecx\n");
    }
    printf("\t%s %%cl,%s\n",op,crn);
    if (change>0 && change!=dreg && regs[REG_ECX]) {
	printf("\txchg %s,%%ecx\n",change);
    }
}

shift_1(op,e) 
char *op;
int e;
{
    int e1,i;
    char *drn;
    drn = reg_name[dreg];
    e1 = car(e);
    if (e1==RGVAR) {
	    printf("\tmovl _%s,%s\n",caddr(e),drn);
    } else if (e1==RLVAR) {
	    printf("\tmovl %d(%%ebp),%s\n",cadr(e),drn);
    } else if (e1==CONST) {
	    i = cadr(e);
	    printf("\t%s $%d,%s\n",op,cadr(e),crn);
	    return;
    } else {
	    error(-1);
    }
    if (dreg!=REG_ECX) {
	printf("\txchg %s,%%ecx\n",reg_name[dreg]);
    }
    printf("\t%s %%cl,%s\n",op,crn);
    /* ޡҤȤĤ顢ܤФregisterľäƤ... */
    if (dreg!=REG_ECX) {
	if (regs[REG_ECX])
	    printf("\txchg %s,%%ecx\n",reg_name[dreg]);
    }
}

lddim(n) /* modified */
int n;
{	printf("\tmovl $%d,%s\n",n,creg);
}


std(e)
int e;
{	switch (car(e))
	{case GVAR:
                printf("\tmovl %s,_%s\n",crn,caddr(e));
		return;
	case LVAR:
                printf("\tmovl %s,$%d(%s)\n",crn,cadr(e),xrn);
		return;
	default:
		DEBUG;
	}
}
leaxy(n) /* modified */
int n;
{	printf("\tmovl $%d,%edi\n",n);
}
leaxu(n) /* modified */
int n;
{	printf("\tmovl $%d,%ebp\n",n);
}

ldx(e)
int e;
{	switch (car(e))
	{case GVAR: case RGVAR:
		printf("\tmovl _%s,%s\n",caddr(e),xrn);
		return;
	case LVAR: case RLVAR:
		printf("\tmovl %d(%%ebp),%s\n",cadr(e),xrn);
		return;
	default:
		DEBUG;
	}
}

stx(e)
int e;
{	switch (car(e))
	{case GVAR:
		printf("\tmovl %s,_%s\n",crn,caddr(e));
		return;
	case LVAR:
		printf("\tmovl %s,%d(%%ebp)\n",crn,cadr(e),xrn);
		return;
	default:
		DEBUG;
	}
}


ldx_indexx(op,n)
char *op;
int n;
{	
        if (n) 
		printf("\t%s %d(%s),%s\n",op,n,xrn,crn);
	else
		printf("\t%s (%s),%s\n",op,xrn,crn);
}
stxindex(op,n)
char *op;
int n;
{	
        if (n) 
		printf("\t%s %s,%d(%s)\n",op,crn,n,xrn);
	else
		printf("\t%s %s,(%s)\n",op,crn,xrn);
}


ld_index(op,e)
char *op;
int e;
{	switch (car(e))
	{case GVAR:
		printf("\t%s _%s,%s\n",op,caddr(e),crn);
		return;
	case LVAR:
		printf("\t%s $%d(%%ebp),%s\n",op,cadr(e),crn);
		return;
	default:
		DEBUG;
	}
}

st_index(op,e)
char *op;
int e;
{	switch (car(e))
	{case GVAR:
		printf("\t%s %s,_%s\n",op,crn,caddr(e));
		return;
	case LVAR:
		printf("\t%s %s,$%d(%%ebp)\n",op,crn,cadr(e));
		return;
	default:
		DEBUG;
	}
}

indexy(op,gvar)
char *op;
char *gvar;
{
        printf("\t%s %s,_%s\n",op,creg,gvar);
}

ld_indir(op,e)
char *op;
int e;
{	switch (car(e))
	{case RGVAR:
		/* indiry(op,cadr(e)); */
		printf("\t%s\t(_%s),%s\n",op,caddr(e),crn);
		return;
	case RLVAR:
		/* indiru(op,cadr(e)); */
		printf("\t%s\t%s(%%epb),%s\n",op,cadr(e),crn);
		return;
	default:
		DEBUG;
	}
}

cexpr(e)
int e;
{	if (car(e) != CONST) error(CNERR);
	return (cadr(e));
}

cmpdimm(e)
int e;
{
	printf("\tcmpl $%d,%s\n",e,crn);
}

global_table() 
{
    NMTBL *n;
    for(n=ntable;n < &ntable[GSYMS];n++) {
	if (n->sc == GVAR) {
	    printf(".comm _%s,%d\n",n->nm,size(n->ty));
	}
    }
}

opening(filename)
char *filename;
{
    printf("\t.file \"%s\"\n",filename);
    printf("gcc2_compiled.:\n");
    printf("___gnu_compiled_c:\n");
    printf(".text\n");
    printf("\t.align 2\n");
    emit_init();
}
closing()
{
    printf("_%d:\n",ilabel);
    printf("\tleave\n");
    printf("\tret\n");
    global_table();
}

gen_gdecl(n,gpc) 
    char *n;
    int gpc;
{
    /* printf("%s\tEQU\t%u\n",n,gpc); */
}

jmp_label(l)
    int l;
{
    printf("\tBRA\t_%d\n",l);
}

jmp_eq_label(l)
    int l;
{
     printf("\tBEQ\t_%d\n",l);
}

rexpr(e1,l1,s)
int e1,l1;
char *s;
{       g_expr(list3(SUB,cadr(e1),caddr(e1)));
        printf("\tj%s\t_%d\n",s,l1);
}
jcond(l,cond)
int l;
char cond;
{       printf("\tj%s\t_%d\n",cond?"ne":"e",l);
}
jmp(l)
int l;
{       control=0;
        printf("\tjmp\t_%d\n",l);
}
fwdlabel()
{       return labelno++;
}
fwddef(l)
int l;
{       control=1;
        printf("_%d:\n",l);
}

backdef()
{       control=1;
        printf("_%d:\n",labelno);
        return labelno++;
}

def_label(cslabel,dlabel) 
    int cslabel,dlabel;
{
    if(dlabel) printf("_%d\tEQU\t_%d\n",cslabel,dlabel);
}

gen_comment(s)
    char *s;
{
     printf("# %s",s);
}

gen_source(s)
    char *s;
{
     printf("%s",s);
}

enter(name,disp) /* modified */
    char *name;
    int disp;
{
        printf(".globl _%s\n",name);
        printf("_%s:\n",name);
        printf("\tpushl %%ebp\n");
        printf("\tmovl %%esp,%%ebp\n");
        printf("\tpushl %%ebx\n");
        printf("\tpushl %%ecx\n");
        printf("\tpushl %%edx\n");
        if(disp) printf("\tsubl $%d,%%esp\n",-disp);
}

ret()
{       
        printf("\tpopl %%edx\n");
        printf("\tpopl %%ecx\n");
        printf("\tpopl %%ebx\n");
	printf("\tleave\n");
	printf("\tret\n");
}

emit_data(e,t)
int e,t;
{
}
